function y = teager(x)
%teager by Rebecca Fiebrink: y = teager(x)
%compute teager operator on signal x, return signal y

%definition: for n from 1 to size(x)-1, y(n) = x(n)^2 - x(n+1)*x(n-1)

sz = size(x, 1);
y(2:sz-1) = x(2:sz-1) .^ 2;
y = y';
y(1) = 0;
y(sz) = 0;
y(2:sz-1) = y(2:sz-1) - x(1:sz-2) .* x(3:sz);
y(1) = y(2);
y(sz) = y(sz-1);